#version 430 core

layout (std140, binding = 0) uniform Common
{
	mat4 view;
	mat4 projection;
	mat4 viewProjection;
	vec3 cameraPos;
	int useDepthTexture;
};

layout (location = 0) in vec3 pos;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 textureCoord;
layout (location = 3) in ivec3 jointIndices;
layout (location = 4) in vec3 weights;


out vec3 FragPos;
out vec3 Normal;
out vec2 TextureCoord;

uniform mat4 model;
uniform mat3 normalMatrix;
//uniform mat4 viewProjection;

void main()
{
    gl_Position = viewProjection * model * vec4(pos, 1.0);
    FragPos = vec3(model * vec4(pos, 1.0));
    Normal = normalMatrix * normal;
	TextureCoord = textureCoord;
}
