#version 430
layout (points) in; // points in
layout (triangle_strip, max_vertices = 4) out; // quads out

layout (std140, binding = 0) uniform Common
{
	mat4 view;
	mat4 projection;
	mat4 viewProjection;
	vec3 cameraPos;
	int useDepthTexture;
};

//uniform mat4 projectionMatrix;
uniform vec2 spriteSize;

in vData { float TTL1; } vertex[];
out vec2 TexCoord0;
flat out float TTL0; // no interpolation between vertices

void main (void) 
{
	vec4 P = gl_in[0].gl_Position; // position in view-space
	TTL0 = vertex[0].TTL1;

	vec2 va = P.xy + vec2(-0.5, -0.5) * spriteSize; // bottom-left corner
	gl_Position = projection * vec4(va, P.zw);
	TexCoord0 = vec2(-1.0, -1.0);
	EmitVertex();

	va = P.xy + vec2(0.5, -0.5) * spriteSize; // bottom-right corner
	gl_Position = projection * vec4(va, P.zw);
	TexCoord0 = vec2(1.0, -1.0);
	EmitVertex();

	va = P.xy + vec2(-0.5, 0.5) * spriteSize; // top-left corner
	gl_Position = projection * vec4(va, P.zw);
	TexCoord0 = vec2(-1.0, 1.0);
	EmitVertex();

	va = P.xy + vec2(0.5, 0.5) * spriteSize; // top-right corner
	gl_Position = projection * vec4(va, P.zw);
	TexCoord0 = vec2(1.0, 1.0);
	EmitVertex();

	EndPrimitive();
}